﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_wheel_zoom
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // The image's original size.
        private int ImageWidth, ImageHeight;

        // The current scale.
        private float ImageScale = 1.0f;

        private void Form1_Load(object sender, EventArgs e)
        {
            ImageWidth = picImage.Image.Width;
            ImageHeight = picImage.Image.Height;
            picImage.SizeMode = PictureBoxSizeMode.Zoom;
            picImage.Size = new Size(ImageWidth, ImageHeight);
            this.MouseWheel += new MouseEventHandler(picImage_MouseWheel);
        }

        // Respond to the mouse wheel.
        private void picImage_MouseWheel(object sender, MouseEventArgs e)
        {
            // The amount by which we adjust scale per wheel click.
            const float scale_per_delta = 0.1f / 120;

            // Update the drawing based upon the mouse wheel scrolling.
            ImageScale += e.Delta * scale_per_delta;
            if (ImageScale < 0) ImageScale = 0;

            // Size the image.
            picImage.Size = new Size(
                (int)(ImageWidth * ImageScale),
                (int)(ImageHeight * ImageScale));

            // Display the new scale.
            lblScale.Text = ImageScale.ToString("p0");
        }

        // Open the book's web page.
        private void lnkPuzzles_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            System.Diagnostics.Process.Start("http://www.csharphelper.com/puzzles.htm");
        }
    }
}
